/* $Header: /src/carson/nistnet/lib/RCS/nistnetlib.c,v 1.3 1998/01/30 17:03:30 carson Exp $ */
/*  General includes */

#include "uincludes.h"
#include "nistnetlib.h"


int hitfd = -1;

int
openhit(void)
{
	if (hitfd < 0) {
		hitfd = open(DEVHITBOX, O_RDWR);
		if (hitfd < 0) {
			return -1;
		}
	}
	return 0;
}

int
hiton(void)
{
	int value=0;

	if (openhit() < 0)
		return -1;
	return ioctl(hitfd, HITIOCTL_ON, &value);
}

int
hitoff(void)
{
	int value=0;

	if (openhit() < 0)
		return -1;
	return ioctl(hitfd, HITIOCTL_OFF, &value);
}

int
addhit(char *src, char *dest, int delay, int delsigma, int bandwidth,
	int drop, int dup, int drdmin, int drdmax, struct lin_hitreq *useradd)
{
	struct hostent *hent;
	struct lin_hitreq *addme, space;

	if (openhit() < 0)
		return -1;
	if (useradd)
		addme = useradd;
	else
		addme = &space;

	bzero((void *)addme, sizeof(struct lin_hitreq));
	addme->delay = delay;
	addme->delsigma = delsigma;
	addme->bandwidth = bandwidth;
	addme->p_drop = drop;
	addme->p_dup = dup;
	addme->drd_min = drdmin;
	addme->drd_max = drdmax;
	if (!src || !*src)
		addme->src = INADDR_ANY;
	else if (isdigit(*src))
		addme->src = inet_addr(src);
	else {
		hent = gethostbyname(src);
		if (!hent) {
			return -1;
		}
		addme->src = *(u_int32_t *)hent->h_addr;
	}
	if (!dest || !*dest)
		addme->dest = INADDR_ANY;
	else if (isdigit(*dest))
		addme->dest = inet_addr(dest);
	else {
		hent = gethostbyname(dest);
		if (!hent) {
			return -1;
		}
		addme->dest = *(u_int32_t *)hent->h_addr;
	}
	return ioctl(hitfd, HITIOCTL_ADD, addme);
}

int
rmhit(struct lin_hitreq *rmme)
{
	if (openhit() < 0)
		return -1;
	return ioctl(hitfd, HITIOCTL_REMOVE, rmme);
}

int
stathit(struct lin_hitstats *statme)
{
	if (openhit() < 0)
		return -1;
	return ioctl(hitfd, HITIOCTL_STATS, statme);
}

int
readhit(struct addrpair *bigguy, int incount)
{
	int count;

	if (openhit() < 0)
		return -1;
	count = read(hitfd, (char *)bigguy, incount*sizeof(struct addrpair));
	count /= sizeof(struct addrpair);
	return count;
}
